/*
  7779_PLATMPO.SQL

  ESTE SCRIPT IR ATUALIZAR A TABELA ITEMRETI, POIS NAS VERSES ANTERIORES AS
  RETIRADAS POR TIPO DE PRATO ERAM GRAVADAS NA TABELA ITEMRETIPRAT, QUE NO EXISTIR.
*/

DECLARE V_TAMANHO          INTEGER;
        V_CDNVPRATO        VARCHAR2(1);
        V_CDPRATO          VARCHAR2(10);
        V_CDPRATOFIX       VARCHAR2(10);
        V_CDPRATOPER       VARCHAR2(10);
        V_ERRO             VARCHAR(2);
BEGIN

   SELECT MAX(CDNVPRATO) INTO V_CDNVPRATO
   FROM PRATO;

   SELECT MAX(CDPRATO) INTO V_CDPRATO
   FROM PRATO
   WHERE (CDNVPRATO = V_CDNVPRATO);

   V_TAMANHO    := LENGTH(V_CDPRATO);
   V_CDPRATOFIX := LPAD('F', V_TAMANHO, 'F');
   V_CDPRATOPER := LPAD('P', V_TAMANHO, 'P');

   /* INCLUI PRATO E TIPO DE PRATO FIXO */
   BEGIN
      INSERT INTO PRATO(CDFILAUXPRAT, CDPRATO, NMPRATO, CDNVPRATO)
      VALUES('P', V_CDPRATOFIX, 'Consumo Fixo', V_CDNVPRATO);
   EXCEPTION
      WHEN DUP_VAL_ON_INDEX THEN BEGIN
         V_ERRO := NULL;
      END;
   END;

   BEGIN
      INSERT INTO TIPOPRAT(CDTIPOPRAT, NMTIPOPRAT)
      VALUES('FF', 'Consumo Fixo');
   EXCEPTION
      WHEN DUP_VAL_ON_INDEX THEN BEGIN
         V_ERRO := NULL;
      END;
   END;

/* INCLUI PRATO E TIPO DE PRATO PER CAPITA */
   BEGIN
      INSERT INTO PRATO(CDFILAUXPRAT, CDPRATO, NMPRATO, CDNVPRATO)
      VALUES('P', V_CDPRATOPER, 'Consumo Percapita', V_CDNVPRATO);
   EXCEPTION
      WHEN DUP_VAL_ON_INDEX THEN BEGIN
         V_ERRO := NULL;
      END;
   END;
   BEGIN
      INSERT INTO TIPOPRAT(CDTIPOPRAT, NMTIPOPRAT)
      VALUES('PP', 'Cons.Percapita');
   EXCEPTION
      WHEN DUP_VAL_ON_INDEX THEN BEGIN
         V_ERRO := NULL;
      END;
   END;

   /*========================================================
   ===== ROTINA PARA GRAVAR PRATO/TIPO DE PRATO DEFAULT =====
   ========================================================*/

   /* ---- CONSUMO FIXO ----- */

   UPDATE PARAMPLANEJA
      SET CDTPRCONSFIX = 'FF'
   WHERE CDTPRCONSFIX  IS NULL;


   UPDATE PARAMPLANEJA
      SET CDFILCONSFIX = 'P',
          CDPRACONSFIX = V_CDPRATOFIX
   WHERE CDPRACONSFIX  IS NULL;

   /* ---- CONSUMO PERCAPITA ----- */

   UPDATE PARAMPLANEJA
      SET CDTPRCONSPER = 'PP'
   WHERE CDTPRCONSPER IS NULL;

   UPDATE PARAMPLANEJA
      SET CDFILCONSPER = 'P',
          CDPRACONSPER = V_CDPRATOPER
   WHERE CDPRACONSPER IS NULL;

   COMMIT;

END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_ITEMRETI','4.11.069'); END;
/
