var Dfe27500_NumeracaoInicialTransmissaoNfe_Controller = function(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise, metaDataFactory, eventEngine, MessageService) {
    
    var widgetCabecalhoEntrada;
    var CDEMPRESA;
    var CDINSCESTA;
    
    var getNumeracaoTransmissaoNfeWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget('cabecalho');
    };
    
    this.getDefaultFilter = function(args) {
        var pai        = getNumeracaoTransmissaoNfeWidget();
        var currentRow = pai.currentRow;
        var gridAmbiente = "";
        
        if(currentRow.IDTPAMBIENTENFE === "1"){
            gridAmbiente = "Produção";
        }
        else {
            gridAmbiente = "Homologação";
        }
        
        getNumeracaoTransmissaoNfeWidget().container.getWidget('Ambiente').label = gridAmbiente;
        var row        = { CDEMPRESA: currentRow.CDEMPRESA, CDINSCESTA: currentRow.CDINSCESTA, NRINSJURIEST: currentRow.NRINSJURIEST, IDTPAMBIENTENFE: currentRow.IDTPAMBIENTENFE };
        
        General.callRestEngine("df_entrada#/getSerieNfe", "Row", row).then(success => {
            let serieNf = success.dataset.NumeracaoSerieNfe;
            let seqSerie = [];
            let rowNovoCodigo = [];
                
            serieNf.forEach(el => {
                let objNovoCodigo = {CDEMPRESA: row.CDEMPRESA, NRINSJURIEST: row.NRINSJURIEST, CDSERIENFE: el.CDSERIENFE, IDTPAMBIENTENFE: row.IDTPAMBIENTENFE};
                rowNovoCodigo.push(objNovoCodigo);
                seqSerie.push(el);
            });
            
            let novoCodigoDb = [];
            let serieFinal = [];
            
            General.callRestEngine("df_entrada#/getNovoCodigo", "Row", rowNovoCodigo).then(success => {
                let dataSetNovoCodigo = success.dataset.NumeracaoNovoCodigo;
                
                dataSetNovoCodigo.forEach(el => {
                    novoCodigoDb.push(el);
                });
                /*
                seqSerie.forEach(elSerie => {
                    novoCodigoDb.forEach(elNovoCodigo => {
                        if(elNovoCodigo.SERIENFE == elSerie.CDSERIENFE) {
                            serieFinal.push(elSerie.concat(elNovoCodigo));
                        }
                    });
                });
                    
                serieFinal = seqSerie.map((eleSerie) => ({
                   ...novoCodigoDb.find((o) => o.SERIENFE == eleSerie.CDSERIENFE),
                   ...eleSerie
                }));
                */
            
                let child = getNumeracaoTransmissaoNfeWidget().container.getWidget('Ambiente');
                child.dataSource.setData(serieFinal);
                child.reload();
                pai.reload();
            });
        });
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    this.empresaOnChange = (widget) => {
        let cnpj = widget.getField("NRINSJURIEST");
        let cnpjFilter = cnpj.dataSourceFilter.find(data => data.name === 'CDEMPRESA');
        
        if(widget.currentRow.CDEMPRESA) cnpjFilter.value = widget.currentRow.CDEMPRESA; 
        
        cnpj.readOnly = !widget.currentRow.CDEMPRESA;
        cnpj.setValue('');
        this.cnpjOnChange(widget);
    };
    
    this.cnpjOnChange = (widget) => {
        let inscricaoEstadual = widget.getField("CDINSCESTA");
        
        if(widget.currentRow.NRINSJURIEST) {
            inscricaoEstadual.dataSourceFilter.forEach( (data) => {
                if(data.name == 'CDEMPRESA')    data.value = widget.currentRow.CDEMPRESA;
                if(data.name == 'NRINSJURIEST') data.value = widget.currentRow.NRINSJURIEST;
            });
        }
        inscricaoEstadual.readOnly = !widget.currentRow.NRINSJURIEST;
        inscricaoEstadual.setValue('');
    };
    
    this.fieldFilterOnChange = function() {
        var widget = templateManager.container.getActiveWidget();
        
        widget.reload();
    };

    this.setCabecalhoWidgetEntrada = function(widget) {
        widgetCabecalhoEntrada =  widget;
    };
    
    this.getCabecalhoWidgetEntrada = function() {
        return widgetCabecalhoEntrada;
    };
    
    this.getFieldValueNotaFiscalOrigem = function(name) {
        if (widgetCabecalhoEntrada && widgetCabecalhoEntrada.currentRow) 
			return widgetCabecalhoEntrada.currentRow[name];
		else 
			return "";
		
    };
    
    this.actConfirmarOnClick = function(args) {
        var documentosWidget = args.owner.widget;
        var rateioCustosWidget = templateManager.container.getWidget("rateioCustos");
        
        General.callRestEngine("df_entrada#/salvarDocumento", "DataSet", documentosWidget.getCheckedRows()).then((response) => {
            MessageService.successNotificationByCode('REGISTRO_SALVO');
            documentosWidget.unSelectAll();
            documentosWidget.reload();
            rateioCustosWidget.activate();
        });
        
    };
    
    
    this.salvaWidgetOnSaveInlineEdit = function(widget) {
        const vrrateioAlterados = widget.dataSource.data.filter(row =>  !!('changed_VRRATEIO' in row));
        
        General.callRestEngine("df_entrada#/salvaRateioIt", "DataSet", widget.dataSource.data).then((response) => {
            
            MessageService.successNotificationByCode('REGISTRO_SALVO');
            
            vrrateioAlterados.forEach(function(rateio){
                rateio.__is_new = false;
                delete rateio.changed_VRRATEIO;
                delete rateio.changed;
            });
            
            widget.list();
        }).catch((error) => {
            MessageService.showMessageByCode(error.data.error);
            
        });
    };
    
    
    this.actConfirmarComposicaoOnClick = function(args) {
        var row = { "CDFILIAL": this.getFieldValueNotaFiscalOrigem("CDFILIAL"),
                    "NRLANCTONF": this.getFieldValueNotaFiscalOrigem("NRLANCTONF"),
                    "NRORG": this.getFieldValueNotaFiscalOrigem("NRORG")
        };
        
        General.callRestEngine("df_entrada#/confirmarComposicao", "Row", row).then(() => {
            MessageService.showMessageByCode('CONFIRMA_COMPOSICAO');
            ScreenService.openWindow('df_entrada#dfe11000_lancamento_entrada');
        });
        
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register('Dfe27500_NumeracaoInicialTransmissaoNfe_Controller', Dfe27500_NumeracaoInicialTransmissaoNfe_Controller);
});