/**
 * Mask used for custom masks. Is possible to create a function to return a wanted mask. The mask should follow the examples on {@link https://igorescobar.github.io/jQuery-Mask-Plugin/docs.html} since we use this plugin.
 * @namespace   fix
 * @memberOf    module:mask
 * @implements  {mask}
 * @property    {String}    params.mask     -   Defines what mask should be used. 
 * @example
    
    //Fix mask example
    
    //Simple ip mask example
    mask: {
        type: "fix",
        params: {
            mask: "999.999.999.999"
        }
    }
    
    //Function returning custom mask example
    mask: {
        type: "fix",
        params: {
            mask: "@function(){
                return 'AAA 000-S0S';     
            }@"
        }
    }
 */ 